/*
 * nobdy
 * Copyright (c) 2010, Kevron Rees.
 *
 * This program is free software; you can redistribute it and/or modify it
 * under the terms and conditions of the GNU Lesser General Public License,
 * version 2.1, as published by the Free Software Foundation.
 *
 * This program is distributed in the hope it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public License for
 * more details.
 *
 * You should have received a copy of the GNU Lesser General Public License along with
 * this program; if not, write to the Free Software Foundation, Inc., 
 * 51 Franklin St - Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */

#ifndef PLUGINLOADER_H
#define PLUGINLOADER_H

#include "ipluginprovider.h"
#include "ipluginsubscriber.h"

#include <QList>

class PluginLoader
{
public:
	PluginLoader(QString config);

	IPluginProvider *provider(){ return m_provider;}
	QList<IPluginSubscriber*> subscribers(){ return m_subscribers;}

private:
	IPluginProvider* m_provider;
	QList<IPluginSubscriber*> m_subscribers;

};

#endif // PLUGINLOADER_H
